; 
;
; In this app the followings are done:
; - create an app window with popup style
; - create D3D9 object
; - create a D3D9 device
;
; - clear the back buffer to blue
;
; 

.586
.model flat, stdcall
option scoped
option casemap:none

	include EmptyProject.inc

; 

.data?
	hMainWnd		dd ?
	hInstance		dd ?
	msg			MSG <>

	lpD3D9			LPDIRECT3D9 ?
	lpD3Ddevice		LPDIRECT3DDEVICE9 ?

.data
	szMainName		db 'EmptyProject',0

	;szFormat		db '%s (%X)',0
	;szDDerror		db 'DirectDraw Error! (%d: %Xh)',0
	;szErrorCaption		db 'Error!',0

	dwScreenWidth		dd 640
	dwScreenHeight		dd 480

	szMainClassName		db 'MainWindowClass',0
	wc			WNDCLASSEX <sizeof WNDCLASSEX,CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW,offset MainWndProc,0,0,,,,,NULL,offset szMainClassName,NULL>

g_pFont				LPD3DXFONT			NULL
;Font_name db "Arial",0
Font_name				db LF_FACESIZE+1 dup (0)
Font_size				dd 0
Font_bold				dd 0
Font_italic			      dd 0
; 
.code
; 
Start:
	invoke GetModuleHandle,NULL
	mov     hInstance,eax
	
	invoke WinMain,hInstance,NULL,NULL,SW_SHOWDEFAULT
@Exit:
	invoke	ExitProcess,0


; 
; WinMain
; 
WinMain		PROC hInst:DWORD,hPrevInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

	; Register window
		mov	eax,hInst
		mov	[wc].hInstance,eax
		;invoke GetStockObject,BLACK_BRUSH
		;mov	wc.hbrBackground,eax
		invoke LoadIcon,NULL,IDI_APPLICATION
		mov	wc.hIcon,eax
		invoke LoadCursor,NULL,IDC_ARROW
		mov	wc.hCursor,eax
		invoke RegisterClassEx,offset wc

	; Create window
	;  WS_CLIPCHILDREN is important this makes it possible
	;  that the DX surface is clipped where the settings dialog is to be displayed
	;  The position and size are not relevant since they get overwritten when processing the WM_CREATE 
		invoke CreateWindowEx,NULL,
			offset szMainClassName,
			offset szMainName,
			WINDOW_STYLE,
			10,10,10,10,
			NULL,NULL,
			hInst,NULL
	; Window creation returned an error?
		or	eax,eax
		jz @ExitLoop

	; Init every component
		invoke initAll
		or	eax,eax
		jnz @Error

		invoke SetFocus,hMainWnd
		invoke ShowWindow,hMainWnd,SW_SHOWDEFAULT


		mov	msg.message,0
	; Endless message loop
@StartLoop:
		cmp	msg.message,WM_QUIT
		jz @ExitLoop
	@@:
		invoke PeekMessage,offset msg,NULL,0,0,PM_REMOVE
		or	eax,eax
		jz @F
		; General processing of hitting ESCAPE causes the app to be closed
		; no matter which control has the focus.
			.IF msg.message==WM_KEYDOWN && msg.wParam==VK_ESCAPE
				invoke PostMessage,hMainWnd,WM_CLOSE,0,0
			.ELSE
				invoke DispatchMessage,offset msg
			.ENDIF
	@@:
		; render here			
			invoke RenderScene

		jmp @StartLoop
@ExitLoop:
		invoke deinitAll
		mov	eax,msg.wParam
@End:
		ret

; 

@Error:
;		invoke wsprintf,lpszAuxText,offset szFormat,edx,eax
;		invoke MessageBox,NULL,lpszAuxText,offset szErrorCaption,MB_OK
;		invoke ShutDownDDraw
		jmp @End

WinMain		ENDP

; 
; Main window procedure
; 
MainWndProc	PROC hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

		mov	 eax,uMsg
; WM_CREATE 
		.IF	eax==WM_CREATE
			m2m	hMainWnd,hWnd

			push	ebx
			sub	esp,size RECT
			mov	ebx,esp
			invoke SetRect,ebx,0,0,dwScreenWidth,dwScreenHeight
			invoke AdjustWindowRectEx,ebx,WINDOW_STYLE,NULL,NULL
			invoke GetSystemMetrics,SM_CYSCREEN
			push	eax
			invoke GetSystemMetrics,SM_CXSCREEN
			mov	ebx,eax
			pop	edx
			mov	eax,[esp+RECT.right]
			mov	ecx,[esp+RECT.bottom]
			sub	eax,[esp+RECT.left]
			sub	ecx,[esp+RECT.top]
			sub	ebx,eax
			sub	edx,ecx
			shr	ebx,1
			shr	edx,1
			invoke MoveWindow,hMainWnd,ebx,edx,eax,ecx,TRUE
			add	esp,size RECT
			pop	ebx

; WM_DESTROY 
		.ELSEIF eax==WM_DESTROY
	@Quit:
			invoke PostQuitMessage,NULL
			xor	eax,eax

; Default 
		.ELSE
@Default:
			invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		.ENDIF
@End:
		ret
; An error occured
;  Stop the frame update timer
;  Display error text and code
@Error:
;		invoke wsprintf,offset szText,offset szDDerror,edx,eax
;		invoke KillTimer,hWnd,WM_PAINT
;		invoke MessageBox,NULL,offset szText,offset szErrorCaption,MB_OK
	; jump to the processing of WM_DESTROY
		jmp @Quit

MainWndProc	ENDP

; 
; Initialize DirectDraw
; 

initAll		PROC

LOCAL d3dpp:D3DPRESENT_PARAMETERS
LOCAL pVertices:DWORD
LOCAL		hdc:DWORD
LOCAL		hFont:DWORD
LOCAL		hFontOld:DWORD
	; init D3D object
		invoke Direct3DCreate9,D3D_SDK_VERSION
		mov	lpD3D9,eax

	; create a device
		lea	eax,d3dpp
		ZeroMemory eax,size D3DPRESENT_PARAMETERS

		mov	d3dpp.Windowed,TRUE
		mov	d3dpp.SwapEffect,D3DSWAPEFFECT_DISCARD
		mov	d3dpp.BackBufferFormat,D3DFMT_UNKNOWN

		coinvoke lpD3D9,IDirect3D9,CreateDevice,\
				D3DADAPTER_DEFAULT,\
				D3DDEVTYPE_HAL,\
				hMainWnd,\
				D3DCREATE_SOFTWARE_VERTEXPROCESSING,\
				addr d3dpp,\
				offset lpD3Ddevice
				
		invoke	CreateCompatibleDC,NULL
       	mov		hdc,eax	

invoke	D3DXCreateFont,lpD3Ddevice,22,20,FW_NORMAL,0,FALSE,DEFAULT_CHARSET,\
                         OUT_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH or FF_DONTCARE,\ 
                         TEXT_("Arial"),addr g_pFont
                         
mov		hFont,eax

	@End:
		ret
initAll		ENDP

deinitAll	PROC

		cmp	lpD3Ddevice,NULL
		jz @F
			coinvoke lpD3Ddevice,IDirect3DDevice9,Release
	@@:
		cmp	lpD3D9,NULL
		jz @F
			coinvoke lpD3D9,IDirect3D9,Release
	@@:
		mov	eax,FALSE
		ret
deinitAll	ENDP

UpdateScene	PROC
	
	
		ret

UpdateScene	ENDP

RenderScene	PROC
LOCAL	rc:RECT
	; clear the scene to dark blue color
		coinvoke lpD3Ddevice,IDirect3DDevice9,Clear,0,NULL,D3DCLEAR_TARGET,00000000h,0,0

		coinvoke lpD3Ddevice,IDirect3DDevice9,BeginScene
		
	      invoke SetRect,addr rc,10,20,0,0
		coinvoke g_pFont,ID3DXFont,DrawTextA,NULL,TEXT_("Draw my text!"),-1,addr rc, DT_LEFT,D3DCOLOR_XRGB(255,0,0)
		
		coinvoke lpD3Ddevice,IDirect3DDevice9,EndScene

	; present the scene		
		coinvoke lpD3Ddevice,IDirect3DDevice9,Present,NULL,NULL,NULL,NULL

		ret
RenderScene	ENDP

end Start